;---------------------------------------------------------
; EJERCICIO 5
; FILTROS FIR
; TMS320 DSP
;
; A modo de ejemplo se implementa un filtro Pasa Bajos de las
; siguientes caracteristicas:
;                               		Order: 63
;                               		Passband Ripple: 3db
;                               		Stopband Attenuation: -60db
;                               		Passband: 1500Hz
;                               		Stopband: 1650Hz
;
; The ej5 filter code used in this example is taken
; from the TMS320C3x Users Guide.  The AIC setup and
; control is designed to work with the TMS320C31 DSK
;---------------------------------------------------------
; Define constants used by program    ;
;---------------------------------------------------------
; AIC timing register values
;
; Sample fr. 9796.24Hz
; Receive Chanel Filter - Antialiasing Filter
; Normalizes Frecuency(KHz)*SCF clock fr/288KHz = 3.55KHz
;
TA        .set     11
TB        .set     29
RA        .set     11
RB        .set     29
;---------------------------------------------------------
GIE       .set     0x2000             		; This bit in ST turns on interrupts
	  .include "C3XMMRS.ASM"      	;
	  .brstart   "AICTEST",64    		; Start assembling here with the coefficieint
	  .sect    "AICTEST"          ;table on a 2^N boundary to 64 location long
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; 32 bit float data buffer of incoming data from the AIC
; The location in memory must be on a 2^N boundary and the
; size of the coefficeint table must be the same as the data
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ADC_recv     	.float    0.0     ;  0
	     	.float    0.0     ;  1
	     	.float    0.0     ;  2
	     	.float    0.0     ;  3
	     	.float    0.0     ;  4
	     	.float    0.0     ;  5
	     	.float    0.0     ;  6
	     	.float    0.0     ;  7
	     	.float    0.0     ;  8
	     	.float    0.0     ;  9
	     	.float    0.0     ; 10
	     	.float    0.0     ; 11
	     	.float    0.0     ; 12
	     	.float    0.0     ; 13
	     	.float    0.0     ; 14
	     	.float    0.0     ; 15
	     	.float    0.0     ; 16
	     	.float    0.0     ; 17
	     	.float    0.0     ; 18
	     	.float    0.0     ; 19
	     	.float    0.0     ; 20
	     	.float    0.0     ; 21
	     	.float    0.0     ; 22
	     	.float    0.0     ; 23
	     	.float    0.0     ; 24
	     	.float    0.0     ; 25
	     	.float    0.0     ; 26
	     	.float    0.0     ; 27
	     	.float    0.0     ; 28
	     	.float    0.0     ; 29
	     	.float    0.0     ; 30
	     	.float    0.0     ; 31
	     	.float    0.0     ; 32
	     	.float    0.0     ; 33
	     	.float    0.0     ; 34
	     	.float    0.0     ; 35
	     	.float    0.0     ; 36
	     	.float    0.0     ; 37
	     	.float    0.0     ; 38
	     	.float    0.0     ; 39
	     	.float    0.0     ; 40
	     	.float    0.0     ; 41
	     	.float    0.0     ; 42
	     	.float    0.0     ; 43
	     	.float    0.0     ; 44
	     	.float    0.0     ; 45
	     	.float    0.0     ; 46
	     	.float    0.0     ; 47
	     	.float    0.0     ; 48
	     	.float    0.0     ; 49
	     	.float    0.0     ; 52
	     	.float    0.0     ; 53
	     	.float    0.0     ; 54
	     	.float    0.0     ; 55
	     	.float    0.0     ; 56
	     	.float    0.0     ; 57
	     	.float    0.0     ; 58
	     	.float    0.0     ; 59
	     	.float    0.0     ; 60
;- - - - - - - - - - - - - - - - - - - - - - - - -
; FIR filter coefficients
;- - - - - - - - - - - - - - - - - - - - - - - - -
;  FIR filter coefficients

FIR_coef     	.float       -9.50540294E-03     ;  0
             		.float       -9.35886553E-03     ;  1
             		.float       -1.23368528E-04     ;  2
             		.float       9.91606486E-03      ;  3
             		.float       1.10832484E-02      ;  4
             		.float       1.54810237E-03      ;  5
             		.float       -1.02919941E-02     ;  6
             		.float       -1.31031575E-02     ;  7
             		.float       -3.33973261E-03     ;  8
             		.float       1.06304609E-02      ;  9
             		.float       1.55434458E-02      ; 10
             		.float       5.64951200E-03      ; 11
             		.float       -1.09289976E-02     ; 12
             		.float       -1.86197869E-02     ; 13
             		.float       -8.74282943E-03     ; 14
             		.float       1.11854199E-02      ; 15
             		.float       2.27360857E-02      ; 16
             		.float       1.31313007E-02      ; 17
             		.float       -1.13978462E-02     ; 18
             		.float       -2.87412365E-02     ; 19
             		.float       -1.99426028E-02     ; 20
             		.float       1.15647137E-02      ; 21
             		.float       3.87635101E-02      ; 22
             		.float       3.22412721E-02      ; 23
             		.float       -1.16847926E-02     ; 24
             		.float       -6.00486194E-02     ; 25
             		.float       -6.22930183E-02     ; 26
             		.float       1.17571967E-02      ; 27
             		.float       1.43340077E-01      ; 28
             		.float       2.69586301E-01      ; 29
             		.float       3.21551942E-01      ; 30
             		.float       2.69586301E-01      ; 31
             		.float       1.43340077E-01      ; 32
             		.float       1.17571967E-02      ; 33
             		.float       -6.22930183E-02     ; 34
             		.float       -6.00486194E-02     ; 35
             		.float       -1.16847926E-02     ; 36
             		.float       3.22412721E-02      ; 37
             		.float       3.87635101E-02      ; 38
             		.float       1.15647137E-02      ; 39
             		.float       -1.99426028E-02     ; 40
             		.float       -2.87412365E-02     ; 41
             		.float       -1.13978462E-02     ; 42
             		.float       1.31313007E-02      ; 43
             		.float       2.27360857E-02      ; 44
             		.float       1.11854199E-02      ; 45
             		.float       -8.74282943E-03     ; 46
             		.float       -1.86197869E-02     ; 47
             		.float       -1.09289976E-02     ; 48
             		.float       5.64951200E-03      ; 49
             		.float       1.55434458E-02      ; 50
             		.float       1.06304609E-02      ; 51
             		.float       -3.33973261E-03     ; 52
             		.float       -1.31031575E-02     ; 53
             		.float       -1.02919941E-02     ; 54
             		.float       1.54810237E-03      ; 55
             		.float       1.10832484E-02      ; 56
             		.float       9.91606486E-03      ; 57
             		.float       -1.23368528E-04     ; 58
             		.float       -9.35886553E-03     ; 59
             		.float       -9.50540294E-03     ; 60
END_coef


;- - - - - - - - - - - - - - - - - - -
BufSz        .set      END_coef - FIR_coef
;- - - - - - - - - - - - - - - - - - -
SIZE         .word    BufSz           ; Size of filter
ADC_first    .word    ADC_recv
ADC_end      .word    FIR_coef
ADC_last     .word    ADC_recv
FIR_coefx    .word    FIR_coef
;------------------------------------
; Define some constant storage data
;------------------------------------
A_REG        .word  (TA<<9)+(RA<<2)+0 	; A registers
B_REG        .word  (TB<<9)+(RB<<2)+2 	; B registers
C_REG        .word  00000111b         	; Control, imput gain *1
                                      			; insert the bandpass filter
S0_gctrl_val .word  0x0E970300        ; Serial port control register values
S0_xctrl_val .word  0x00000111        ;
S0_rctrl_val .word  0x00000111        ;
;****************************************************
; Begin main code loop here
;****************************************************
main      or    GIE,ST          	; Turn on INTS
	  ldi   0xF4,IE         	; Enable XINT/RINT/INT2
	  b     main            	; Do it again!
;-------------------------------
DAC2      push  ST              ; DAC Interrupt service routine
	  push  R0              	;
	  pushf R0              	;
	  push  R2              	;
	  pushf R2              	;
	  push  AR0             	;
	  push  AR1             	;
	  ldi   @ADC_last,AR1   ;
	  ldi   @FIR_coefx,AR0  ;
	  ldi   @SIZE,BK
FIR       mpyf3 *AR0++,*AR1++(1)%,R0
	  ldf   0.0,R2
	  ldi   @SIZE,RC
	  subi  2,RC
	  rptb  FIR2
	  mpyf3 *AR0++,*AR1++(1)%,R0
FIR2  ||  addf3 R0,R2,R2
	  addf  R2,R0
	  fix   R0,R0
	  mpyi  4,R0
	  andn  3,R0            	;
	  sti   R0,@S0_xdata   ; Output the new DAC value
	  pop   AR1             	;
	  pop   AR0             	;
	  popf  R2              	;
	  pop   R2              	;
	  popf  R0              	;
	  pop   R0              	;
	  pop   ST              	;
	  reti                  	;
;-------------------------------
ADC2      push  ST              	;
	  push  R3              	;
	  pushf R3              	;
	  push  AR0             	;
	  ldi   @S0_rdata,R3   ;

	  lsh   16,R3
	  ash   -16,R3

	  ldi   @ADC_last,AR0
	  float R3,R3
	  stf   R3,*AR0++

	  cmpi  @ADC_end,AR0
	  ldige @ADC_first,AR0
	  sti   AR0,@ADC_last

	  pop   AR0
	  popf  R3              	;
	  pop   R3              	;
	  pop   ST              	;
	  reti                  	;
;*****************************************************;
; The startup stub is used during initialization only ;
; and can be safely overwritten by the stack or data  ;
;*****************************************************;
	  .entry   ST_STUB      ; Debugger starts here
ST_STUB   ldp   T0_ctrl         ; Use kernel data page and stack
	  ldi   @stack,SP
	  ldi   0,R0            	; Halt TIM0 & TIM1
	  sti   R0,@T0_ctrl     ;
	  sti   R0,@T0_count    ; Set counts to 0
	  ldi   1,R0            	; Set periods to 1
	  sti   R0,@T0_prd      ;
	  ldi   0x3C1,R0        	; Restart both timers
	  sti   R0,@T0_ctrl     ;
	  ;---------------------
	  ldi   @S0_xctrl_val,R0;
	  sti   R0,@S0_xctrl    	; transmit control
	  ldi   @S0_rctrl_val,R0	;
	  sti   R0,@S0_rctrl    		; receive control
	  ldi   0,R0            ;
	  sti   R0,@S0_xdata    	; DXR data value
	  ldi   @S0_gctrl_val,R0	; Setup serial port
	  sti   R0,@S0_gctrl    	; global control
;======================================================;
; This section of code initializes the AIC             ;
;======================================================;
AIC_INIT  LDI   0x10,IE      ; Enable only XINT interrupt
	  andn  0x34,IF         	;
	  ldi   0,R0            	;
	  sti   R0,@S0_xdata    ;
	  RPTS  0x040           ;
	  LDI   2,IOF           	; XF0=0 resets AIC
	  rpts  0x40            	;
	  LDI   6,IOF           	; XF0=1 runs AIC
	  ;---------------------
	  ldi   @C_REG,R0       ; Setup control register
	  call  prog_AIC        	;
	  ldi   0xfffc  ,R0     	; Program the AIC to be real slow
	  call  prog_AIC        	;
	  ldi   0xfffc|2,R0     	;
	  call  prog_AIC        	;
	  ldi   @B_REG,R0     ; Bump up the Fs to final rate
	  call  prog_AIC        	; (smallest divisor should be last)
	  ldi   @A_REG,R0    ;
	  call  prog_AIC        	;
	  b     main            	; the DRR before going to the main loop
;-------------------------------
prog_AIC  ldi   @S0_xdata,R1    ; Use original DXR data during 2 ndy
	  sti   R1,@S0_xdata    ;
	  idle
	  ldi   @S0_xdata,R1   ; Use original DXR data during 2 ndy
	  or    3,R1            	; Request 2 ndy XMIT
	  sti   R1,@S0_xdata   ;
	  idle                  	;
	  sti   R0,@S0_xdata   ; Send register value
	  idle                  	;
	  andn  3,R1            	;
	  sti   R1,@S0_xdata   ; Leave with original safe value in DXR
	  ;---------------------
	  ldi   @S0_rdata,R0   ; Fix the receiver underrun by reading
	  rets                  	;
stack     .word   $             	; Put stack here
;****************************************************;
; Install the XINT/RINT ISR handler directly into    ;
; the vector RAM location it will be used for        ;
;****************************************************;
	  .start   "SP0VECTS",0x809FC5
	  .sect    "SP0VECTS"
	  B        DAC2         ; XINT0
	  B        ADC2         ; RINT0


